/**
  * @author tianyanrong
  */
import React, { Component } from 'react';
import 'react-quill/dist/quill.snow.css';
import {CheckOutlined} from '@ant-design/icons';
import {Input} from 'antd';
import styles from './index.module.less';
import {getOutputType} from '@icode-run/utils/es/dataType';

class ValueInput extends Component {
  state = {};

  static getDerivedStateFromProps(nextProps, prevState) {
    const {outputValue = {}} = nextProps;
    const propsOutputValue = typeof outputValue.value === 'string' ? outputValue.value : JSON.stringify(outputValue.value);
    console.log(88888, nextProps, propsOutputValue, prevState.propsOutputValue)
    if(propsOutputValue !== prevState.propsOutputValue) {
      return {
        value: propsOutputValue,
        propsOutputValue,
      }
    }
    return null;
  }

  setOutputValue = async() => {
    const {value} = this.state;
    const {
      outputValue = {},
      outputType={}
    } = this.props;

    let newValue;
    let type;
    try{
      newValue = (new Function(`return ${value}`))();
      if(typeof newValue === 'number' && newValue !== Number(value)) {
        throw '';
      }
      type = getOutputType(newValue);
    }catch(e) {
      type = 'string';
      newValue = value;
    }
    
    console.log('------outputType', type, value);
    if(outputType.onChange && typeof outputType.onChange === 'function') {
      await outputType.onChange(type);
    }
    if(outputValue.onChange && typeof outputValue.onChange === 'function') {
      console.log('------outputValue', newValue);
      await outputValue.onChange(newValue);
    }
    
  }

  render() {
    const {
      className = '', 
      style = {}, 
      bordered = false,
      size, 
      outputValue = {},
      outputType={}
    } = this.props;
    const {value = '', propsOutputValue = ''} = this.state;
    return <div className={`${styles.item} icode-value-input ${className}`} style={style}>
      <Input 
        bordered={bordered} 
        size={size} 
        value={value}
        onBlur={() => {
          this.setOutputValue();
        }}
        addonAfter={<CheckOutlined
          style={value !== propsOutputValue ? {color: 'var(--icode-primary-color)'} : {color: '#aaa'}}
          onClick={() => {
            this.setOutputValue();
          }}
        />}
        onChange={(e) => {
          this.setState({
            value: e.target.value
          })
        }}
      />
    </div>;
  }
}
export default ValueInput;
